﻿Imports System.Collections.Concurrent
Imports System.Threading
Imports System.Threading.Tasks

Module Module1

    Sub Main()
        ' Construct a ConcurrentQueue
        Dim cq As New ConcurrentQueue(Of Integer)()

        ' Populate the queue
        For i As Integer = 0 To 9999
            cq.Enqueue(i)
        Next

        ' Peek at the first element
        Dim result As Integer
        If Not cq.TryPeek(result) Then
            Console.WriteLine("CQ: TryPeek failed when it should have succeeded")
        ElseIf result <> 0 Then
            Console.WriteLine("CQ: Expected TryPeek result of 0, got {0}", result)
        End If

        Dim outerSum As Integer = 0

        ' An action to consume the ConcurrentQueue
        Dim action As Action =
            Sub()
                Dim localValue As Integer
                Dim localSum As Integer = 0
                While cq.TryDequeue(localValue)
                    localSum += 1
                End While
                Interlocked.Add(outerSum, localSum)
            End Sub

        ' Start 4 concurrent consuming actions
        Parallel.Invoke(action, action, action, action)

        Console.WriteLine("outerSum = {0}, should be 10000", outerSum)
        Console.ReadLine()
    End Sub

End Module
