﻿Module Sort
    Public Delegate Function Compare(ByVal v1 As Object, ByVal v2 As Object) As Boolean 'define delegate

    ''' <summary>
    ''' Sort the data using the provided compare method
    ''' </summary>
    ''' <param name="dataToSort">Data to sort</param>
    ''' <param name="GreaterThen">delegate to comparer delivering true if 1st object is greater than 2nd, else false</param>
    ''' <remarks>implements bubble sort</remarks>
    Public Sub DoSort(ByVal dataToSort() As Object, ByVal GreaterThen As Compare)
        Dim outer As Integer    'index outer element
        Dim inner As Integer    'index inner element
        Dim temp As Object      'helper element

        For outer = 0 To UBound(dataToSort)
            For inner = outer + 1 To UBound(dataToSort)
                'delegate must be called using Invoke(), Invoke does not need to be written
                If GreaterThen.Invoke(dataToSort(outer), dataToSort(inner)) Then
                    'swap inner and outer elements
                    temp = dataToSort(outer)
                    dataToSort(outer) = dataToSort(inner)
                    dataToSort(inner) = temp
                End If
            Next
        Next
    End Sub
End Module
