'Diese Klasse implementiert
'   Public Properties fr ua DataBinding
'   parameterloser Konstruktor fr XML Serialisierung
'   INotifiyPropertyChanged fr DataBinding
'   IComparable fr Sortieren nach einem Kriterium: Name
'   und besitzt nested classes, die IComparer implementieren

Imports System.ComponentModel

Public Enum Genders
    Female
    Male
End Enum

<Serializable()> _
Public Class Student
    Implements INotifyPropertyChanged   'fr DataBinding
    Implements IComparable      'fr sortieren nach dem 1. Kriterium
    'Implements IComparer        'fr Sortieren nach mehreren Kriterien

    Private mName As String
    Public Property Name() As String
        Get
            Return mName
        End Get
        Set(ByVal value As String)
            mName = value
        End Set
    End Property

    Private mFirstName As String
    Public Property FirstName() As String
        Get
            Return mFirstName
        End Get
        Set(ByVal value As String)
            mFirstName = value
        End Set
    End Property

    Private mBirthDate As DateTime
    Public Property BirthDate() As DateTime
        Get
            Return mBirthDate
        End Get
        Set(ByVal value As DateTime)
            mBirthDate = value
        End Set
    End Property

    Private mID As Integer
    Public ReadOnly Property ID() As Integer
        Get
            Return mID
        End Get
    End Property

    Private Shared mCount As Integer = 0

    Public Sub New(ByVal gender As Genders, ByVal name As String, ByVal firstname As String, ByVal birthDate As DateTime)
        mGender = gender
        mName = name
        mFirstName = firstname
        mBirthDate = birthDate
        mID = mCount        'use counter to create the ID, starting at 0
        mCount += 1
    End Sub

    Private Sub New()   'for XML serialization

    End Sub

    Private mGender As Genders
    Public Property Gender() As Genders
        Get
            Return mGender
        End Get
        Set(ByVal value As Genders)
            mGender = value
        End Set
    End Property

    Public ReadOnly Property Sign() As SunSign
        'sorted by date:
        'Aquarius    'Aquarius (January 20 - February 18): Humanitarian, unconventional, sometimes detached. 
        'Pisces      'Pisces (February 19 - March 20): Imaginative, sensitive, sometimes impractical. 
        'Aries       'Aries (March 21 - April 19): Assertive, impulsive, sometimes selfish. 
        'Taurus      'Taurus (April 20 - May 20): Resourceful thorough, sometimes indulgent. 
        'Gemini      'Gemini (May 21 - June 20): Logical, inquisitive, sometimes superficial. 
        'Cancer      'Cancer (June 21 - July 22): Tenacious, sensitive, sometimes clinging. 
        'Leo         'Leo (July 23 - August 22): Generous, proud, sometimes arrogant. 
        'Virgo       'Virgo (August 23 - September 22): Practical, efficient, sometimes over-critical. 
        'Libra       'Libra (September 23 - October 22): Co-operative, fair, sometimes lazy. 
        'Scorpio     'Scorpio (October 23 - November 21): Passionate, sensitive, sometimes obsessive. 
        'Sagittarius 'Sagittarius (November 22 - December 21): intelligent, straightforward, sometimes careless. 
        'Capricorn   'Capricorn (December 22 - January 19): Prudent, ambitious, sometimes suspicious. 

        Get
            If (mBirthDate.Month = 1) Then
                If (mBirthDate.Day >= 20) Then
                    Return SunSign.Aquarius
                Else
                    Return SunSign.Capricorn
                End If

            ElseIf (mBirthDate.Month = 2) Then
                If (mBirthDate.Day >= 19) Then
                    Return SunSign.Pisces
                Else
                    Return SunSign.Aquarius
                End If

            ElseIf (mBirthDate.Month = 3) Then
                If (mBirthDate.Day >= 21) Then
                    Return SunSign.Aries
                Else
                    Return SunSign.Pisces
                End If

            ElseIf (mBirthDate.Month = 4) Then
                If (mBirthDate.Day >= 20) Then
                    Return SunSign.Taurus
                Else
                    Return SunSign.Aries
                End If

            ElseIf (mBirthDate.Month = 5) Then
                If (mBirthDate.Day >= 21) Then
                    Return SunSign.Gemini
                Else
                    Return SunSign.Taurus
                End If

            ElseIf (mBirthDate.Month = 6) Then
                If (mBirthDate.Day >= 21) Then
                    Return SunSign.Cancer
                Else
                    Return SunSign.Gemini
                End If

            ElseIf (mBirthDate.Month = 7) Then
                If (mBirthDate.Day >= 23) Then
                    Return SunSign.Leo
                Else
                    Return SunSign.Cancer
                End If

            ElseIf (mBirthDate.Month = 8) Then
                If (mBirthDate.Day >= 23) Then
                    Return SunSign.Virgo
                Else
                    Return SunSign.Leo
                End If

            ElseIf (mBirthDate.Month = 9) Then
                If (mBirthDate.Day >= 23) Then
                    Return SunSign.Libra
                Else
                    Return SunSign.Virgo
                End If

            ElseIf (mBirthDate.Month = 10) Then
                If (mBirthDate.Day >= 23) Then
                    Return SunSign.Scorpio
                Else
                    Return SunSign.Libra
                End If

            ElseIf (mBirthDate.Month = 11) Then
                If (mBirthDate.Day >= 22) Then
                    Return SunSign.Sagittarius
                Else
                    Return SunSign.Scorpio
                End If

            ElseIf (mBirthDate.Month = 12) Then
                If (mBirthDate.Day >= 22) Then
                    Return SunSign.Capricorn
                Else
                    Return SunSign.Sagittarius
                End If
            Else
                Throw New Exception("internall error - could not determine sign")
            End If
        End Get
    End Property

    Public Overrides Function ToString() As String
        Return ("Student ID: " & mID.ToString & ", Name: " & mName & ", " & mFirstName & vbTab & ", Born: " & mBirthDate & "; Gender: " & mGender.ToString)
    End Function

#Region "Property Changed Event"
    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Protected Overridable Sub OnPropertyChanged(ByVal propertyName As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
    End Sub

#End Region

#Region "Shared functions for various array sorts"
    Public Function CompareTo(ByVal obj As Object) As Integer Implements System.IComparable.CompareTo
        'If Not (TypeOf obj Is Student) Then Throw New ApplicationException("obj must be of type 'Student'.")

        '   Verwendung: dim i as integer = A.CompareTo(B)
        '               i < 0   wenn A < B
        '               i = 0   wenn A = B
        '               i > 0   wenn A > B

        'If Me.Name < CType(obj, Student).Name Then
        '    Return -1
        'ElseIf Me.Name = CType(obj, Student).Name Then
        '    Return 0
        'Else
        '    Return 1
        'End If

        'krzer:
        Return (Me.Name.CompareTo(CType(obj, Student).Name))
    End Function


    'the shared functions offers an easy call to sort: eg Array.Sort(arrayOfStudents, Student.SortByBirthdate)
    Public Shared Function SortByBirthdate() As IComparer(Of Student)
        Return CType(New SortByBirthdateHelper, IComparer(Of Student))
    End Function

    Public Shared Function SortByGender() As IComparer(Of Student)
        Return CType(New SortByGenderHelper, IComparer(Of Student))
    End Function

    Public Shared Function SortBySunSign() As IComparer(Of Student) 'Sternzeichen
        Return CType(New SortBySunSignHelper, IComparer(Of Student))
    End Function
#End Region

#Region "Nested classes needed for additional array sort criterias"
    'these classes are needed for additional sort criterias
    'generic comparer to be used by generic List(Of T) !!!
    Public Class SortByBirthdateHelper
        Implements IComparer(Of Student)

        'for normal comparer:
        'Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
        '    'If Not ((TypeOf x Is Student) AndAlso (TypeOf y Is Student)) Then Throw New ApplicationException("Both objects must be of type 'Student'.")
        '    Dim birthdate1 As DateTime = CType(x, Student).BirthDate
        '    Dim birthdate2 As DateTime = CType(y, Student).BirthDate
        '    birthdate1.CompareTo(birthdate2)
        'End Function

        Public Function Compare(ByVal x As Student, ByVal y As Student) As Integer Implements System.Collections.Generic.IComparer(Of Student).Compare
            Return x.BirthDate.CompareTo(y.BirthDate)
        End Function
    End Class

    Public Class SortByGenderHelper     'sort ladies first
        Implements IComparer(Of Student)


        'for normal comparer:
        'Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
        '    'If Not ((TypeOf x Is Student) AndAlso (TypeOf y Is Student)) Then Throw New ApplicationException("Both objects must be of type 'Student'.")
        '    Dim gender1 As Genders = CType(x, Student).Gender
        '    Dim gender2 As Genders = CType(y, Student).Gender
        '    If gender1 = gender2 Then
        '        Return 0
        '    ElseIf gender1 = Genders.Female And gender2 = Genders.Male Then
        '        Return -1
        '    Else
        '        Return 1
        '    End If
        'End Function

        Public Function Compare(ByVal x As Student, ByVal y As Student) As Integer Implements System.Collections.Generic.IComparer(Of Student).Compare
            If x.Gender = y.Gender Then
                Return 0
            ElseIf x.Gender = Genders.Female And y.Gender = Genders.Male Then
                Return -1
            Else
                Return 1
            End If
        End Function
    End Class

    Public Class SortBySunSignHelper
        Implements IComparer(Of Student)


        'for normal comparer:
        'Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer Implements System.Collections.IComparer.Compare
        '    'If Not ((TypeOf x Is Student) AndAlso (TypeOf y Is Student)) Then Throw New ApplicationException("Both objects must be of type 'Student'.")

        '    'because the sign enum is ordered by asceding date, we can compare the values of the enum items
        '    Dim sign1 As SunSign = CType(x, Student).Sign
        '    Dim sign2 As SunSign = CType(x, Student).Sign
        '    Return sign1.CompareTo(sign2)
        'End Function

        Public Function Compare(ByVal x As Student, ByVal y As Student) As Integer Implements System.Collections.Generic.IComparer(Of Student).Compare
            Return x.Sign.CompareTo(y.Sign)
        End Function
    End Class
#End Region

#Region "Shared functions for various collection sorts"
    'uses Comparison(Of T) Generic Delegate
    'this methods are required for sorting List(of T) collections

    Public Shared Function CompareByBirthdate(ByVal x As Student, ByVal y As Student) As Integer
        Return x.BirthDate.CompareTo(y.BirthDate)
    End Function

    Public Shared Function CompareByGender(ByVal x As Student, ByVal y As Student) As Integer
        If x.Gender = y.Gender Then
            Return 0
        ElseIf x.Gender = Genders.Female And y.Gender = Genders.Male Then
            Return -1
        Else
            Return 1
        End If
    End Function

    Public Shared Function CompareBySunSign(ByVal x As Student, ByVal y As Student) As Integer
        Return x.Sign.CompareTo(y.Sign)
    End Function
#End Region
End Class


Public Enum SunSign
    'from Wikipedia
    'the signs are sorted by date to enable us to easily compare them for a sorting order!
    Aquarius    'Aquarius (January 20 - February 18): Humanitarian, unconventional, sometimes detached. 
    Aries       'Aries (March 21 - April 19): Assertive, impulsive, sometimes selfish. 
    Cancer      'Cancer (June 21 - July 22): Tenacious, sensitive, sometimes clinging. 
    Capricorn   'Capricorn (December 22 - January 19): Prudent, ambitious, sometimes suspicious. 
    Gemini      'Gemini (May 21 - June 20): Logical, inquisitive, sometimes superficial. 
    Leo         'Leo (July 23 - August 22): Generous, proud, sometimes arrogant. 
    Libra       'Libra (September 23 - October 22): Co-operative, fair, sometimes lazy. 
    Pisces      'Pisces (February 19 - March 20): Imaginative, sensitive, sometimes impractical. 
    Sagittarius 'Sagittarius (November 22 - December 21): intelligent, straightforward, sometimes careless. 
    Scorpio     'Scorpio (October 23 - November 21): Passionate, sensitive, sometimes obsessive. 
    Taurus      'Taurus (April 20 - May 20): Resourceful thorough, sometimes indulgent. 
    Virgo       'Virgo (August 23 - September 22): Practical, efficient, sometimes over-critical. 
End Enum

