Imports System.Text

<Serializable()> _
Public Class Department
    Implements IComparable

    Private mSchoolClasses As New List(Of SchoolClass)
    Public Property SchoolClasses() As List(Of SchoolClass)
        Get
            Return mSchoolClasses
        End Get
        Set(ByVal value As List(Of SchoolClass))
            mSchoolClasses = value
        End Set
    End Property

    Private Shared mCount As Integer = 0
    Private mID As Integer

    Public ReadOnly Property ID() As Integer
        Get
            Return mID
        End Get
    End Property


    Private mName As String
    Public Property Name() As String
        Get
            Return mName
        End Get
        Set(ByVal value As String)
            mName = value
        End Set
    End Property

    Public Sub New(ByVal name As String)
        mID = mCount
        mCount += 1
        mName = name
    End Sub

    Private Sub New()   'for XML serialization

    End Sub

    Public Overrides Function ToString() As String
        Dim sb As New StringBuilder
        sb.Append("Department ID: " & mID & ", Name: " & mName & ", Nr. of classes: " & mSchoolClasses.Count)
        For Each s As SchoolClass In mSchoolClasses
            sb.Append(vbCrLf & vbTab & vbTab & s.ToString)
        Next
        Return sb.ToString
    End Function

    Public Function CompareTo(ByVal obj As Object) As Integer Implements System.IComparable.CompareTo
        'compare name of dept.
        Return Me.Name.CompareTo(CType(obj, SchoolClass).Name)
    End Function

    Public Sub SortStudentsByGender()
        For Each sc As SchoolClass In mSchoolClasses
            sc.SortStudentsByGender()
        Next
    End Sub

    Public Sub SortStudentsBySunSign()  'Sternzeichen
        For Each sc As SchoolClass In mSchoolClasses
            sc.SortStudentsBySunSign()
        Next
    End Sub

    Public Sub SortStudentsByBirthdate()  '
        For Each sc As SchoolClass In mSchoolClasses
            sc.SortStudentsByBirthdate()
        Next
    End Sub
End Class
