Imports System.Text
Imports System.ComponentModel

<Serializable()> _
Public Class SchoolClass
    Implements INotifyPropertyChanged
    Implements IComparable

    'Der Umbauvon mStudents auf eine BindingList(Of T) erfordert nderungen des DatenTypes in allen 
    'aufrufenden Methoden. Alternativ kann man mit DataSource/BindingSource aus eine List eine 
    'BindingList machen.
    'BindingLits(Of T).OrderBy erfordert LINQ function delegate.
    'siehe meine DataBinding Manuals.
    Private mStudents As New List(Of Student)
    Public Property Students() As List(Of Student)
        Get
            Return mStudents
        End Get
        Set(ByVal value As List(Of Student))
            mStudents = value
        End Set
    End Property


    Private mClassName As String
    Public Property Name() As String
        Get
            Return mClassName
        End Get
        Set(ByVal value As String)
            mClassName = value
        End Set
    End Property


    Private mRoom As String
    Public Property Room() As String
        Get
            Return mRoom
        End Get
        Set(ByVal value As String)
            mRoom = value
        End Set
    End Property

    Private Shared mCount As Integer = 0
    Private mID As Integer

    Public ReadOnly Property ID() As Integer
        Get
            Return mID
        End Get
    End Property

    Public Sub New(ByVal className As String, ByVal room As String)
        mID = mCount
        mCount += 1
        mClassName = className
        mRoom = room
    End Sub

    Private Sub New()   'for XML serialization

    End Sub

    Public Overrides Function ToString() As String
        Dim sb As New StringBuilder
        sb.Append("Schoolclass ID: " & mID & ", ClassName: " & mClassName & ", Room: " & mRoom & ", Nr. of Students: " & mStudents.Count)
        For Each s As Student In mStudents
            sb.Append(vbCrLf & vbTab & vbTab & vbTab & s.ToString)
        Next
        Return sb.ToString
    End Function

    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Public Function CompareTo(ByVal obj As Object) As Integer Implements System.IComparable.CompareTo
        'compare name of class
        Return Me.Name.CompareTo(CType(obj, SchoolClass).Name)
    End Function

#Region "Sort List(of T)"
    'uses Comparison(Of T) Generic Delegate

    Public Sub SortStudentsByName()
        mStudents.Sort()    'use default comparer
    End Sub

    Public Sub SortStudentsByGender()
        mStudents.Sort(AddressOf Student.CompareByGender)
    End Sub

    Public Sub SortStudentsBySunSign()  'Sternzeichen
        mStudents.Sort(AddressOf Student.CompareBySunSign)
    End Sub

    Public Sub SortStudentsByBirthdate()  '
        mStudents.Sort(AddressOf Student.CompareByBirthdate)
    End Sub
#End Region
End Class
