﻿Module Module1
    Dim customerList As New List(Of Customer) _
        From {New Customer With {.ContactName = "Mustermann", .CustomerID = 1},
              New Customer With {.ContactName = "Maier", .CustomerID = 2},
              New Customer With {.ContactName = "Müller", .CustomerID = 3},
              New Customer With {.ContactName = "Lehmann", .CustomerID = 4},
              New Customer With {.ContactName = "Schulze", .CustomerID = 5}}

    Sub Main()
        Console.WindowWidth = 120

        ' returns collection of customer objects with ID > 2
        Dim result1 = From c In customerList
            Where c.CustomerID > 2
            Select c

        Console.WriteLine("Type of collection result1: " & result1.GetType.ToString)
        Console.WriteLine("Type of item in collection result1: " & result1(0).GetType.ToString)
        For Each item In result1
            Console.WriteLine(item.ToString())
        Next
        Console.WriteLine(vbCrLf)

        ' returns collection of anonymous types
        Dim result2 = From c In customerList Select c.CustomerID, c.ContactName

        Console.WriteLine("Type of collection result2: " & result2.GetType.ToString)
        Console.WriteLine("Type of item in collection result2: " & result2(0).GetType.ToString)
        For Each item In result2
            Console.WriteLine(item.ToString())
        Next
        Console.WriteLine(vbCrLf)

        ' returns collection of anonymous types
        Dim result3 = From c In customerList
                Select New With
                       {.CustomerID = c.CustomerID,
                        .ContactName = c.ContactName}

        Console.WriteLine("Type of collection result3: " & result3.GetType.ToString)
        Console.WriteLine("Type of item in collection result3: " & result3(0).GetType.ToString)
        For Each item In result3
            Console.WriteLine(item.ToString())
        Next
        Console.WriteLine(vbCrLf)

        ' returns collection of customer objects
        Dim result4 = From c In customerList
                Select New Customer With
                       {.CustomerID = c.CustomerID,
                        .ContactName = c.ContactName}

        Console.WriteLine("Type of collection result4: " & result4.GetType.ToString)
        Console.WriteLine("Type of item in collection result4: " & result4(0).GetType.ToString)
        For Each item In result4
            Console.WriteLine(item.ToString())
        Next
        Console.WriteLine(vbCrLf)

        ' returns collection of customer objects
        'note: in VB.NET you don't need to write Select !
        Dim result5 = From c In customerList
            Where c.CustomerID > 2

        Console.WriteLine("Type of collection result5: " & result1.GetType.ToString)
        Console.WriteLine("Type of item in collection result5: " & result1(0).GetType.ToString)
        For Each item In result5
            Console.WriteLine(item.ToString())
        Next
        Console.WriteLine(vbCrLf)

        Console.ReadLine()
    End Sub

    Class Customer
        Property CustomerID As Integer
        Property ContactName As String

        Public Overrides Function ToString() As String
            Return "ID: " & Me.CustomerID & ": " & Me.ContactName
        End Function
    End Class

End Module
