'funktioniert!
'test the CaseConverterStream

'zeigt drei Varianten Stream bzw Reader/Writer
'beachte, wie kurz der Sourcecode bei den beiden unteren Varianten ist !!!

Imports System.IO
Imports System.Text
Imports MyOwnStreams


Module Module1
    Const INPUTFILE As String = "myFileIn.txt"
    Const OUTPUTFILE As String = "myFileOut.txt"

    Sub Main()
        Console.Title = "StreamLowerCaseConverter"
        Console.WriteLine("batch test: convert to upper case" & vbCrLf)

        'delete the output file if it exists
        If My.Computer.FileSystem.FileExists(OUTPUTFILE) Then My.Computer.FileSystem.DeleteFile(OUTPUTFILE)

        If My.Computer.FileSystem.FileExists(INPUTFILE) Then
            Using fsInput As New FileStream(INPUTFILE, FileMode.Open, FileAccess.Read)
                Using converter As New CaseConverterStream(fsInput, Conversions.ToUpperCase)
                    Using fsOutput As New FileStream(OUTPUTFILE, FileMode.CreateNew, FileAccess.Write)  'CreateNew throws execption if file already exists
                        Dim readCount As Integer            'Read returns the number of bytes actually read in from stream
                        Dim buffer(4095) As Byte

                        Do
                            'read from input stream and convert
                            readCount = converter.Read(buffer, 0, buffer.Length)    'conversion happens here!
                            If readCount > 0 Then                'alternativ Exit Do
                                Console.WriteLine(vbTab & readCount & " bytes read from input file and converting ...")

                                'output the byte value and the character it represents
                                For i As Integer = 0 To readCount - 1
                                    Console.WriteLine(vbTab & "Byte " & i & ": " & buffer(i) & vbTab & Chr(buffer(i)))        'raw byte
                                Next

                                'write to output stream
                                Console.WriteLine(vbTab & "Writing output file ...")
                                fsOutput.Write(buffer, 0, readCount)
                            End If
                        Loop While readCount > 0
                        fsOutput.Flush()                        'make sure everything is on disk

                    End Using
                End Using
            End Using
        Else
            Console.WriteLine("Cannot open input file: " & INPUTFILE)
            Console.ReadLine()
        End If
        Console.WriteLine("Hit Enter to Exit.")
        Console.ReadLine()

        '-----------------------------------------------------------------------------------
        'mit StreamReader/StreamWriter geht das ganze viel einfacher:
        '-----------------------------------------------------------------------------------

        'Using sr As New StreamReader(INPUTFILE)
        '    Using sw As New StreamWriter(OUTPUTFILE)
        '        Do Until sr.EndOfStream
        '            sw.WriteLine(sr.ReadLine.ToUpper)
        '        Loop
        '    End Using         ' this actually writes data to the file and closes it.
        'End Using

        '-----------------------------------------------------------------------------------
        'und wenn die Datei ins Memory passt, dann geht's auch so:
        '-----------------------------------------------------------------------------------
        'Using sr As New StreamReader(INPUTFILE), sw As New StreamWriter(OUTPUTFILE)
        '    sw.WriteLine(sr.ReadToEnd.ToUpper)
        'End Using


    End Sub

End Module
