﻿'demonstrate how to watch a directory for added files
'this could be used by a ftp server handling incoming files

Imports System.IO

Module Module1

    Const DIRECTORY As String = "C:\temp"

    Dim WithEvents fsw As FileSystemWatcher

    Sub Main()
        fsw = New FileSystemWatcher(DIRECTORY)
        fsw.NotifyFilter = (NotifyFilters.LastAccess Or NotifyFilters.LastWrite _
                            Or NotifyFilters.FileName Or NotifyFilters.DirectoryName)
        fsw.Filter = "*.txt"
        fsw.EnableRaisingEvents = True

        Console.WriteLine("Hit Enter to exit.")
        Console.ReadLine()
    End Sub

    Private Sub fsw_Changed(sender As Object, e As System.IO.FileSystemEventArgs) _
        Handles fsw.Changed, fsw.Created, fsw.Deleted
        Console.WriteLine("File {0} was changed: {1}", e.FullPath, e.ChangeType.ToString)
    End Sub

    Private Sub fsw_Renamed(sender As Object, e As System.IO.RenamedEventArgs) _
        Handles fsw.Renamed
        Console.WriteLine("File {0} was renamed to {1}.", e.FullPath, e.OldFullPath)
    End Sub

    Private Sub fsw_Error(sender As Object, e As System.IO.ErrorEventArgs) _
        Handles fsw.Error
        Console.WriteLine("A buffer error happened: {0}.", e.GetException.ToString)
    End Sub
End Module
