﻿'shows how to search a directory tree recursively.
'simply returns all found files

Imports System.IO

Module Module1

    Const DIRECTORY As String = "C:\HTL 0203"
    Const PATTERN As String = "*.doc"

    Sub Main()
        'list all files using SearchDirectory()
        Dim sb As New System.Text.StringBuilder(vbCrLf)
        For Each fi In SearchDirectory(New DirectoryInfo(DIRECTORY), PATTERN)
            sb.AppendLine(fi.FullName)
        Next
        Console.WriteLine(sb.ToString)

        'list all files using SearchDirectoryShort()
        sb.Clear()
        sb.AppendLine()
        For Each fi In SearchDirectoryShort(New DirectoryInfo(DIRECTORY), PATTERN)
            sb.AppendLine(fi.FullName)
        Next
        Console.WriteLine(sb.ToString)

        Console.ReadLine()
    End Sub

    ''' <summary>
    ''' Return list of files from given directory and its subdirectories matching the pattern
    ''' </summary>
    ''' <param name="Dir">start directory for search</param>
    ''' <param name="pattern">filename pattern</param>
    ''' <returns>list of fileinfos</returns>
    ''' <remarks></remarks>
    Function SearchDirectory(dir As DirectoryInfo, pattern As String) As List(Of FileInfo)
        'list to return fileinfo objects
        Dim l As New List(Of FileInfo)

        'process all files in directory
        For Each File In dir.GetFiles(pattern)
            l.Add(File)
        Next

        'recursively call the function for each subdirectory
        For Each subdir In dir.GetDirectories
            l.AddRange(SearchDirectory(subdir, pattern))
        Next

        Return l
    End Function

    ''' <summary>
    ''' Return list of files from given directory and its subdirectories matching the pattern
    ''' </summary>
    ''' <param name="startDir">start directory for search</param>
    ''' <param name="pattern">filename pattern</param>
    ''' <returns>list of fileinfos</returns>
    ''' <remarks>
    ''' This is the same method as SearchDirectory, written in a shorter manner
    ''' </remarks>
    Function SearchDirectoryShort(startDir As DirectoryInfo, pattern As String) As List(Of FileInfo)
        'search all subdirectories
        Return startDir.GetFiles(pattern, SearchOption.AllDirectories).ToList
    End Function

End Module
