﻿Imports System.Xml

Module Module1

    Sub Main()
        Dim doc As New XmlDocument()    'create DOM xml structure in memory
        doc.Load("mycars.xml")              'load xml file into memory
        Call OutputNode(doc.DocumentElement)    'recursive output
        Console.Read()
    End Sub

    Private Sub OutputNode(ByVal node As XmlNode)
        'output the current element node
        Console.WriteLine("Type=" & node.NodeType.ToString & vbTab & "Name=" & node.Name & vbTab & "Value=" & node.Value)

        'handle attributes 
        If Not IsNothing(node.Attributes) Then
            For Each att As XmlAttribute In node.Attributes
                Console.WriteLine(vbTab & "Type=" & att.NodeType.ToString & vbTab & "Name=" & att.Name & vbTab & "Value=" & att.Value)
            Next
        End If

        'handle child nodes recursively
        If node.HasChildNodes Then
            'get collection of child nodes
            Dim children As XmlNodeList = node.ChildNodes
            For Each child In children
                'and output each one (recursive call)
                Call OutputNode(child)
            Next
        End If
    End Sub
End Module
