﻿Imports System.Xml
Imports System.IO

Module Module1

    Sub Main()
        'read from MyCars.xml
        'Call ReadMyCars()

        'write to MyCars.xml
        Call WriteMyNextCar()

        Console.WriteLine("Hit Enter to exit.")
        Console.ReadLine()
    End Sub

    Private Sub ReadMyCars()
        Dim reader As New XmlTextReader("mycars.xml")
        Try
            reader.WhitespaceHandling = WhitespaceHandling.None

            'handle elements:
            Do While (reader.Read())
                Console.WriteLine("Type=" & reader.NodeType.ToString & vbTab & "Name= " & reader.Name & vbTab & "Value= " & reader.Value)
                'handle attributes:
                If (reader.AttributeCount > 0) Then
                    Do While (reader.MoveToNextAttribute)
                        Console.WriteLine(vbTab & "Type=" & reader.NodeType.ToString & vbTab & "Name= " & reader.Name & vbTab & "Value= " & reader.Value)
                    Loop
                End If
            Loop

        Catch ex As Exception
            Console.WriteLine("Error: " & ex.Message)
        Finally
            If Not IsNothing(reader) Then
                reader.Close()
            End If
        End Try
    End Sub

    Private Sub WriteMyNextCar()
        Dim writer As XmlTextWriter = Nothing

        Try
            writer = New XmlTextWriter("MyNextCar.xml", System.Text.Encoding.Unicode)
            writer.Formatting = Formatting.Indented

            writer.WriteStartDocument()
            writer.WriteStartElement("MyCollection")

            writer.WriteStartElement("Manufacturer")
            writer.WriteAttributeString("Name", "Opel")
            writer.WriteAttributeString("City", "Rüsselsheim")

            writer.WriteStartElement("Model")
            writer.WriteAttributeString("Name", "Astra G")

            writer.WriteElementString("ManufactureDate", "2001")
            writer.WriteElementString("Power", "75")
            writer.WriteElementString("Torque", "199")
            writer.WriteElementString("Consumption", "5.4")
            writer.WriteElementString("Acceleration", "10.4")
            writer.WriteElementString("TopSpeed", "175")

            writer.WriteEndElement()
            writer.WriteEndElement()

            writer.WriteEndElement()
            writer.WriteEndDocument()

        Catch ex As Exception
            Console.WriteLine("Error: " & ex.Message)
        Finally
            If Not IsNothing(writer) Then
                writer.Close()
            End If
        End Try
    End Sub
End Module
